diff --git a/configure.ac b/configure.ac
index dc39dbe..cbd5a6f 100644
--- a/configure.ac
+++ b/configure.ac
@@ -199,6 +199,10 @@ ndctl_keysreadme=keys.readme
 AC_SUBST([ndctl_keysdir])
 AC_SUBST([ndctl_keysreadme])
 
+AC_CHECK_HEADERS([iniparser.h],,[
+		  AC_MSG_ERROR([iniparser.h not found, install iniparser-devel, libiniparser-dev, or so])
+		 ])
+
 my_CFLAGS="\
 -Wall \
 -Wchar-subscripts \
diff --git a/Makefile.am b/Makefile.am
index 60a1998..c547459 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -70,6 +70,8 @@ noinst_LIBRARIES += libutil.a
 libutil_a_SOURCES = \
 	util/parse-options.c \
 	util/parse-options.h \
+	util/parse-configs.c \
+	util/parse-configs.h \
 	util/usage.c \
 	util/size.c \
 	util/main.c \
diff --git a/util/parse-configs.h b/util/parse-configs.h
new file mode 100644
index 0000000..32783b5
--- /dev/null
+++ b/util/parse-configs.h
@@ -0,0 +1,38 @@
+// SPDX-License-Identifier: GPL-2.0
+// Copyright (C) 2021, FUJITSU LIMITED. ALL rights reserved.
+
+#include <dirent.h>
+#include <stdbool.h>
+#include <stdint.h>
+#include <string.h>
+#include <util/util.h>
+
+enum parse_conf_type {
+	CONFIG_STRING,
+	CONFIG_END,
+	MONITOR_CALLBACK,
+};
+
+int filter_conf_files(const struct dirent *dir);
+
+struct config;
+typedef int parse_conf_cb(const struct config *, const char *config_file);
+
+struct config {
+	enum parse_conf_type type;
+	const char *key;
+	void *value;
+	void *defval;
+	parse_conf_cb *callback;
+};
+
+#define check_vtype(v, type) ( BUILD_BUG_ON_ZERO(!__builtin_types_compatible_p(typeof(v), type)) + v )
+
+#define CONF_END() { .type = CONFIG_END }
+#define CONF_STR(k,v,d) \
+	{ .type = CONFIG_STRING, .key = (k), .value = check_vtype(v, const char **), .defval = (d) }
+#define CONF_MONITOR(k,f) \
+	{ .type = MONITOR_CALLBACK, .key = (k), .callback = (f)}
+
+int parse_configs_prefix(const char *config_path, const char *prefix,
+			 const struct config *configs);
diff --git a/util/parse-configs.c b/util/parse-configs.c
new file mode 100644
index 0000000..61352d8
--- /dev/null
+++ b/util/parse-configs.c
@@ -0,0 +1,105 @@
+// SPDX-License-Identifier: GPL-2.0
+// Copyright (C) 2021, FUJITSU LIMITED. ALL rights reserved.
+
+#include <dirent.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <iniparser/iniparser.h>
+#include <sys/stat.h>
+#include <util/parse-configs.h>
+#include <util/strbuf.h>
+
+int filter_conf_files(const struct dirent *dir)
+{
+	if (!dir)
+		return 0;
+
+	if (dir->d_type == DT_REG) {
+		const char *ext = strrchr(dir->d_name, '.');
+
+		if ((!ext) || (ext == dir->d_name))
+			return 0;
+		if (strcmp(ext, ".conf") == 0)
+			return 1;
+	}
+
+	return 0;
+}
+
+static void set_str_val(const char **value, const char *val)
+{
+	struct strbuf buf = STRBUF_INIT;
+	size_t len = *value ? strlen(*value) : 0;
+
+	if (!val)
+		return;
+
+	if (len) {
+		strbuf_add(&buf, *value, len);
+		strbuf_addstr(&buf, " ");
+	}
+	strbuf_addstr(&buf, val);
+	*value = strbuf_detach(&buf, NULL);
+}
+
+static int parse_config_file(const char *config_file,
+			const struct config *configs)
+{
+	dictionary *dic;
+
+	if ((configs->type == MONITOR_CALLBACK) &&
+			(strcmp(config_file, configs->key) == 0))
+		return configs->callback(configs, configs->key);
+
+	dic = iniparser_load(config_file);
+	if (!dic)
+		return -errno;
+
+	for (; configs->type != CONFIG_END; configs++) {
+		switch (configs->type) {
+		case CONFIG_STRING:
+			set_str_val((const char **)configs->value,
+					iniparser_getstring(dic,
+					configs->key, configs->defval));
+			break;
+		case MONITOR_CALLBACK:
+		case CONFIG_END:
+			break;
+		}
+	}
+
+	iniparser_freedict(dic);
+	return 0;
+}
+
+int parse_configs_prefix(const char *config_path, const char *prefix,
+			 const struct config *configs)
+{
+	const char *config_file = NULL;
+	struct dirent **namelist;
+	int rc, count;
+
+	if (configs->type == MONITOR_CALLBACK)
+		return parse_config_file(config_path, configs);
+
+	count = scandir(config_path, &namelist, filter_conf_files, alphasort);
+	if (count == -1)
+		return -errno;
+
+	while (count--) {
+		char *conf_abspath;
+
+		config_file = namelist[count]->d_name;
+		rc = asprintf(&conf_abspath, "%s/%s", config_path, config_file);
+		if (rc < 0)
+			return -ENOMEM;
+
+		rc = parse_config_file(conf_abspath, configs);
+
+		free(conf_abspath);
+		if (rc)
+			return rc;
+	}
+
+	return 0;
+}
diff --git a/ndctl/Makefile.am b/ndctl/Makefile.am
index a63b1e0..afdd03c 100644
--- a/ndctl/Makefile.am
+++ b/ndctl/Makefile.am
@@ -56,7 +56,8 @@ ndctl_LDADD =\
 	../libutil.a \
 	$(UUID_LIBS) \
 	$(KMOD_LIBS) \
-	$(JSON_LIBS)
+	$(JSON_LIBS) \
+	-liniparser
 
 if ENABLE_KEYUTILS
 ndctl_LDADD += -lkeyutils